; Nota sulle API di Ollie's Follies
;$1582 - Update schermo completo (Comprensivo di caratteri)
;$162F - ClearScreen
;$1c00 - Preimpostazione livello (colori)
;$1592 - Carica livello in $38 (Mappa schermo)
;$0c54 - Carica colori in $38
;$1b1e - Interruzione ($FFFE)
exitbutton	equ	"Q"
gamebutton	equ	"G"
savebutton	equ	"S"
clearbutton	equ	"0"
waittime	equ	$05
joyport		equ $dc01
temp2		equ	$f6
temp		equ $F7		; F7 	=> 1 byte
mapsave		equ $F8		; F8/F9 => 2 byte
pointer		equ	$Fa		; FA/FB	=> 2 byte
fromsprite	equ	$Fc		; FC/FD => 2 byte
tosprite	equ	$Fe		; FE/FF => 2 byte
startmap	equ	$a000
endmap		equ $c7ff
startgame	equ	$093a
spritereal	equ	$d000
screenbase	equ	$4000

*=$c800	
	ldy #<riga3
	ldx #>riga3
	lda #$80
	jsr PrintOnSprite
	ldy #<riga1
	ldx #>riga1
	lda #$00
	jsr PrintOnSprite
	ldy #<riga2
	ldx #>riga2
	lda #$40
	jsr PrintOnSprite	
	jsr StartVideo
	lda #$00	; Inizializzazione dati
	sta $38
	lda #<startmap
	sta mapsave
	lda #>startmap
	sta mapsave+1		
UpdateMap
	ldy #<space
	ldx #>space
	lda #$4d
	jsr PrintOnSprite
	jsr UpdateScreen
	ldx $1591
	inx
	txa
	ora #$30
	sta number+1
	ldy #<(number+1)
	ldx #>(number+1)
	lda #$0e
	jsr PrintOnSprite
	sec
	jsr SetMapForSprite
	lda #$00
	sta spritebase+$15	
	ldy #<mode1
	ldx #>mode1
	lda #$46
	jsr PrintOnSprite
	lda $38
	jsr HexToDec
	stx number
	sty number+1	
	ldy #<number
	ldx #>number
	lda #$06
	jsr PrintOnSprite
	jsr GetMem
	ldy #<(riga1+$14)
	ldx #>(riga1+$14)
	lda #$14
	jsr PrintOnSprite
MainLoop
	ldx #waittime
	jsr GetJoystick
	bcc MLJoy
	jsr CheckKey
	bcc UpdateMap
	bmi MainLoop
	jmp togame
MLJoy	
	cmp #$04
	bne *+4
	dec $38	; Sinistra
	cmp #$08
	bne *+4
	inc $38	; Destra
	cmp #$10
	bne UpdateMap
	lda #$03
	sta spritebase+$15
	ldy #<mode2
	ldx #>mode2
	lda #$46
	jsr PrintOnSprite
	jmp TSStart
	
;***********************
; MENU SCELTA CARATTERE
;***********************

Character	
	ldx #waittime
	jsr GetJoystick
	bcc CHJoy	
	jsr CheckKey
	bcc UM
	bmi Character
	jmp togame		
CHJoy	
	ldx #$00
	jsr JoyMoveMask
	ldx #$00
	jsr UpdateSpritePosition	
	bcc Character	
	lda #$00
	jsr SpriteCharPosition
	jsr CoordToRam
	stx tosprite
	sty tosprite+1	
	jsr WaitJoy
	ldy #<select
	ldx #>select
	lda #$4d
	jsr PrintOnSprite
ToSelect	
	ldx #waittime
	jsr GetJoystick
	bcc TSJoy
	jsr CheckKey
	bcs TSEnd	
UM	
	jmp UpdateMap
TSEnd	
	bmi ToSelect
	jmp togame
TSJoy	
	ldx #$01
	jsr JoyMoveMask
	ldx #$01
	jsr UpdateSpritePosition	
	bcc ToSelect
	lda #$01
	jsr SpriteCharPosition	
	jsr CoordToRam
	stx fromsprite
	sty fromsprite+1
	ldy #$00
	lda (fromsprite),y
	sta (tosprite),y	
	jsr WaitJoy
TSStart	
	ldy #<edit
	ldx #>edit
	lda #$4d
	jsr PrintOnSprite	
	jmp Character
	
	
;---------------------------------------------------------------------------------------------
; A POSTO!
;---------------------------------------------------------------------------------------------	
;*************************
; Controllo tasto premuto
;*************************
; Input:
;	A => Tasto premuto
; Output:
;	C => Uscita al gioco (1)
CheckKey
	and #$7f
	cmp #$31
	bne NoOne
	lda #$00
	sta $1591
	bpl SetChar
NoOne
	cmp #$32
	bne NoTwo
	lda #$01
	sta $1591
	bpl SetChar
NoTwo
	cmp #$33
	bne NoThree
	lda #$02
	sta $1591
	bpl SetChar
NoThree	
	cmp #savebutton
	bne NoSave
	jsr SaveMap
CKExitUM
	clc
	rts
NoSave
	cmp #gamebutton
	bne NoGame
	lda #$00
	sec
	rts	
NoGame
	cmp #exitbutton
	bne NoExit	
	beq CKExitUM	
NoExit	
	cmp #clearbutton
	bne CKExit
	jsr $162f
	jsr SetMenu
	clc
	bcc CKExit	
SetChar	
	adc #$30
	sta number+1
	ldy #<(number+1)
	ldx #>(number+1)
	lda #$0e
	jsr PrintOnSprite	
	jsr $1642
CKExit	
	lda #$80
	sec
	rts
	
;********************************************************
; Update posizione sprite in base al valore del joystick
;********************************************************
; Input:
;	A => Valore letto dal joystick (0-1F)
;	X => Numero di sprite
; Output:
;	C => Tasto premuto o meno (1/0)
UpdateSpritePosition	
	sta temp
	txa
	tay
	asl
	tax
	lda spritebase+1,x
	lsr temp
	bcc *+4
	sbc #$08
	lsr temp
	bcc *+4
	adc #$07
	sta spritebase+1,x
	tya
	pha
	lda spritebase+$10
USPgethb
	lsr
	dey
	bpl USPgethb
	pla
	tay
	lda spritebase,x
	ror
	php
	lsr temp
	bcc *+4
	sbc #$04
	lsr temp
	bcc *+4
	adc #$03
	plp
	rol
	sta spritebase,x
	lda spritebase+$10
	and masks+8,y
	bcc *+5
	ora masks,y
	sta spritebase+$10
	lsr temp	
	rts
	
	
;********************************************************************
; Maschera l'input del joystick per adattarlo alla finestra d'azione
;********************************************************************
; Input:
;	A => Valore letto dal joystick (0-1F)
;	X => Numero di sprite (serve per riferirsi alla finestra giusta)
; Output:
;	A => Valore mascherato del joystick
JoyMoveMask
	sta temp
	txa
	asl
	asl
	clc
	adc #<windows
	sta JMMcheckx+1
	clc
	adc #$02
	sta JMMchecky+1	
	txa
	jsr SpriteCharPosition	
	lda #$1F
	jsr JMMchecky	
	bne *+4
	eor #$01
	inc JMMchecky+1
	jsr JMMchecky
	bne *+4
	eor #$02
	jsr JMMcheckx
	bne	*+4
	eor #$04
	inc JMMcheckx+1
	jsr JMMcheckx
	bne *+4
	eor #$08
	and temp	
	rts
JMMcheckx	
	cpx windows
	rts
JMMchecky	
	cpy windows
	rts

	
;************************************************
; Calcola la posizione in caratteri dello sprite
;************************************************
; input: 
;	A => numero dello sprite (0-7)
; output:
;	X => Posizione orizzontale (0-39)
;	Y => Posizione verticale (0-24)
SpriteCharPosition	
	tax
	asl
	tay
	lda spritebase+$10
SCPoverflow
	lsr
	dex
	bpl SCPoverflow
	lda spritebase,y
	ror
	lsr
	lsr
	sec
	sbc #$02
	tax
	lda spritebase+1,y
	sec
	sbc #$31
	lsr
	lsr
	lsr
	tay
	rts

	
;*****************************************************
; Calcola la posizione in RAM in base alle coordinate
;*****************************************************
; Input:
; X => Coordinata X (0-39)
; Y => Coordinata Y (0-24)
; Output:
; X => Lo byte RAM
; Y => Hi byte RAM
CoordToRam
	tya
	sta temp
	asl
	asl
	clc
	adc temp
	asl
	asl
	rol temp
	asl
	rol temp
	clc
	ldy temp
	stx temp
	adc temp
	tax
	tya
	adc #$00
	and #$03
	ora #>screenbase
	tay
	rts


;*******************
; Salvataggio mappa
;*******************
; Sala la mappa nel livello indicato da $38
SaveMap
	lda #$00
	sta spritebase+$15
	lda $38
	asl
	tax	
	lda mapsave	
	sta $15fd,x
	sec
	lda mapsave+1
	sbc #$64
	sta $15fe,x	
	ldy #$77
resettitle	
	lda #$00
	sta screenbase,y
	dey	
	bpl resettitle		
	lda $1591
	sta screenbase
	lda #$00
	sta $43f8
	sta $43f9	
	ldy mapsave
	sta mapsave	
	tax
	lda #>screenbase
	sta SMsavescreen+2
	lda #$7F
	sta temp	
	clc
SMsavescreen	
	lda screenbase
	inc SMsavescreen+1
	bne SMcompare	
	inc SMsavescreen+2
	ldx SMsavescreen+2
	cpx #$44
	bne SMcompare
	sec
SMcompare	
	tax
	bne SMnonzerosave		
	inc temp
	lda temp
	eor #$ff	
	beq SMnonzerosave
	bcs SMnonzerosave
	bne SMsavescreen
SMnonzerosave		
	lda	temp	
	bpl SMnoresetT
SMresetT	
	sta (mapsave),y
	jsr SMUpdY
	lda #$7F
	sta temp
SMnoresetT	
	txa
	beq SMskipne
	sta (mapsave),y
	jsr SMUpdY
SMskipne	
	bcc SMsavescreen
	sty mapsave
	rts
SMUpdY	
	iny
	bne *+4
	inc mapsave+1
	rts
;************************
; Inizializzazione video	
;************************
StartVideo
	lda #$36
	sta $01
	lda #$96
	sta $dd00
	lda #$03
	sta $d018
	lda #$00
	sta $d020
	sta $d021
	lda #$18
	sta $d016
	lda #$17
	sta spritebase
	lda #$49
	sta spritebase+1
	lda #$17
	sta spritebase+2
	lda #$31
	sta spritebase+3	
	lda #$01
	sta spritebase+$27
	lda #$06
	sta spritebase+$28
	sei
	lda #<IRQhandler
	sta $0314
	lda #>IRQhandler
	sta $0315
	lsr $d019
	lda #$01
	sta $d01a
	lda #$7f
	sta $dc0d
	sta $dd0d
	lda $dc0d
	lda $dd0d
	lda #$00
	sta $d012
	cli
	rts

	
;***********************************************
; Update dello schermo in base al valore di $38	
;***********************************************
; $38 => Livello selezionato
UpdateScreen		
	lda $38
	and #$1F
	cmp #$18
	bcc USok38
	beq *+4
	lda #$0f
	eor #$18
USok38	
	sta $38	
	and #$03
	tax
	lda $0c86,x
	sta $d022
	lda $0c8a,x
	sta $d023
USWait	
	lda $d011
	bpl USWait
	lda #$03
	sta $d011
	jsr $0c54	; Imposta colori caratteri
	jsr $1595	; Disegna mappa schermo
	jsr $1642	; Sistema i caratteri delle mappe 0/1/2
	lda #$1b
	sta $d011
	;jsr $19B0	
	;jsr $19e6
	jsr SetMenu
	;jsr $27d5
	jsr $2f6f
	lda #$70
	sta $43f8		
	sta $43f9	
	rts
	

;***********************************************
; Attende che il joy torni in posizione normale
;***********************************************
WaitJoy
	lda joyport
	and #$1f
	eor #$1f
	bne WaitJoy
	lda #$00
	sta $c6
	rts

		
.include "GetKeyJoy.asm"	
;************************************************************	
; Legge dal joystick nell'accumulatore (esce su special key)
;************************************************************
; X=WaitTime (1=>4.5ms)
; Output:
; C=0 => A=Joystick (Normalizzato)
; C=1 => A=Keyboard
GetJoystick		
	stx pointer+1
	lda #$00
	sta pointer	
GJWait	
	jsr GetKeyJoy
	beq GJWait2
	dec pointer
	bne GJWait
	dec pointer+1
	bne GJWait
GJWait2
	jsr GetKeyJoy
	beq GJWait2
GJExit		
	cmp #$80
	and #$7f			
	rts		
	

;******************************
; Visualizza il menu dei pezzi
;******************************

SetMenu
	ldy #119
SMCopy	
	lda menu1,y
	sta screenbase,y
	lda #$0f
	sta $D800,y
	dey
	bpl SMCopy
	rts

	
;*****************
; IRQ Hyperscreen
;*****************

IRQhandler
	lsr $d019
	lda $d012
	cmp #$f0
	bcs IRQ2
	lda #$f9
	sta $d012
	lda $d011	
	and #$7f
	ora #$08
	sta $d011	
	ldx #$00
IRQresetsprite	
	lda spritebase,x
	sta spritereal,x
	inx
	cpx #$11
	bne IRQresetsprite	
	lda spritebase+$27
	sta spritereal+$27
	lda spritebase+$28
	sta spritereal+$28
	lda spritebase+$15
	sta spritereal+$15	
	lda #$70
	sta $43f8
	sta $43f9
	jmp $ea81
IRQ2	
	lda #$00
	sta $d012
	lda $d011
	and #$77	
	sta $d011
	lda #$ff
	sta $d015
	clc
	lda #$24
	sta $d000
	adc #$18
	sta $d002
	adc #$18
	sta $d004
	adc #$18
	sta $d006
	adc #$18
	sta $d008
	adc #$18
	sta $d00a
	adc #$18
	sta $d00c
	adc #$18
	sta $d00e
	lda #$ff
	sta $d001
	sta $d003
	sta $d005
	sta $d007
	sta $d009
	sta $d00b
	sta $d00d
	sta $d00f
	lda #$01
	sta $d027
	sta $d028
	sta $d029
	sta $d02a
	sta $d02b
	sta $d02c
	sta $d02d
	sta $d02e	
	lda #$00
	sta $d010
	lda #$74
	sta $43f8
	lda #$75
	sta $43f9
	lda #$76	
	sta $43fa
	lda #$77
	sta $43fb
	lda #$78	
	sta $43fc
	lda #$79
	sta $43fd
	lda #$7a	
	sta $43fe
	lda #$7b
	sta $43ff	
	jmp $ea81


;***********************************************
; IMPOSTA/ELIMINA Caratteri per Player ed Enemy
;***********************************************
; C=1 => Imposta
; C=0 => Elimina	

SetMapForSprite
	ldy #$0f
	lda #$00
SMFSCopy
	bcc *+4
	lda map,y
	sta $4870,y
	dey
	bpl SMFSCopy
	ldy #$07
SMFSCopy2
	bcc *+4
	lda map+$10,y
	sta $4978,y
	dey
	bpl SMFSCopy2
	rts

	
;*********************
; SCRIVI SUGLI SPRITE
;*********************
; Y: low byte address
; X: high byte address
; A: 6/7 => Y
; A: 0-4 => X

PrintOnSprite
	sty $20
	stx $21
	sta $22
	asl
	rol
	rol
	and #$03
	sta $23
	lda $22
	and #$1f
	sta $22
	sei
	lda #$33
	sta $01
	ldy #$00
POSloop	
	jsr POSupdater
	lda ($20),y
	and #$bf
	beq POSexit
	sty $26
	asl
	rol $25
	asl
	rol $25
	asl
	rol $25
	sta $24
	lda $25
	and #$07
	ora #$d0
	sta $25
	lda #$00
	tax
	tay
POScopier	
	lda ($24),y	
POSsaver	
	sta $5d00,x
	inx
	inx
	inx
	iny
	cpy #$08
	bne POScopier
	inc $22	
	ldy $26
	iny
	bne POSloop
POSexit		
	lda #$36
	sta $01
	cli
	rts		
POSupdater
	ldx #$00	
	lda $22
POSdiv3
	cmp #$03
	bcc POSdivok	
	sbc #$03
	inx
	bne POSdiv3
POSdivok	
	sta $27
	txa 
	asl
	rol $28
	asl
	rol $28
	asl
	rol $28
	asl
	rol $28
	asl
	rol $28
	asl
	rol $28
	clc
	adc $27
	sta $27
	lda $23
	asl
	adc $23
	asl
	asl
	asl
	adc $27
	sta POSsaver+1
	lda $28	
	and #$3f
	adc #$5d
	sta POSsaver+2	
	rts
	

;************
; Hex To Dec
;************
; A: Input
; -----------------
; X: High - Output
; Y: Low

HexToDec		
		sed
		sta temp
		lda #$00
		sta temp2
		ldx #$08
HTDCnvBit		
		asl temp
		adc temp2
		sta temp2
		dex
		bne HTDCnvBit
		pha
		lsr
		lsr
		lsr
		lsr
		ora #$30
		tax
		pla
		and #$0f
		ora #$30
		tay
		cld		
		rts				


;*********
; Get MEM
;*********

GetMem
		sec
		lda #<endmap
		sbc mapsave
		tax
		lda #>endmap
		sbc mapsave+1
		tay
		lsr
		lsr
		lsr
		lsr
		jsr FixHex
		sta riga1+$14+$00
		tya
		and #$0f
		jsr FixHex
		sta riga1+$14+$01
		txa
		lsr
		lsr
		lsr
		lsr
		jsr FixHex
		sta riga1+$14+$02
		txa
		and #$0f
		jsr FixHex
		sta riga1+$14+$03
		rts
FixHex	ora #$30
		cmp #$3a
		bcc FHExit
		adc #$06
FHExit	rts				

togame	sei			; FIX
		lda #$00
		tay
prereset
		sta $fd30,y
		dey
		bne prereset
		jmp startgame
		
menu1	
.byte $0b,$0c,$0d,$0d,$0d,$0d,$07,$08,$17,$1D,$1B,$1B,$18,$30,$31,$32,$33,$34,$63,$64,$65,$4C,$4D,$4E,$4F,$5D,$5E,$5B,$5C,$3B,$3C,$3D,$3E,$00,$6C,$6D,$6E,$45,$46,$00
.byte $01,$02,$03,$04,$05,$06,$09,$0A,$13,$14,$15,$16,$1C,$35,$36,$37,$38,$39,$66,$67,$68,$50,$51,$52,$53,$56,$57,$59,$5A,$3F,$40,$41,$42,$43,$6F,$70,$71,$00,$00,$00
.byte $47,$48,$10,$1C,$0E,$0F,$11,$12,$19,$49,$0D,$19,$1A,$7E,$7F,$7B,$7C,$7D,$69,$6A,$6B,$5F,$60,$61,$62,$54,$55,$00,$58,$19,$44,$0d,$19,$1a,$3A,$3A,$2F,$1E,$1E,$00

map
.byte $FC,$CC,$CC,$FC,$C0,$C0,$C0,$00
.byte $FC,$C0,$C0,$F0,$C0,$C0,$FC,$00
.byte $C0,$C0,$C0,$C0,$C0,$C0,$FC,$00

masks
.byte $01,$02,$04,$08,$10,$20,$40,$80
.byte $FE,$FD,$FB,$F7,$EF,$DF,$BF,$7F

align 8
windows
.byte $00,$27,$03,$17	; Finestra primo sprite
.byte $00,$27,$00,$02	; Finestra secondo sprite
align $80

;------                        -----
riga1
.byte "LEVEL:00 CHAR:0 MEM:XXXX",$00
riga2
.byte "MODE:                   ",$00
riga3
.byte "                        ",$00
mode1
.byte "CHOOSE",$00
mode2
.byte "MODIFY  ",$00
edit
.byte "(EDIT)  ",$00
select
.byte "(SELECT)",$00
space
.byte "        ",$00
number
.byte $00,$00,$00
spritebase
.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
